using Demo.Data.LocalData;
using Demo.domain.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Demo.Data.Repository
{
    public class UserRepositoryImpl:IUserRepository
    {
        public UserRepositoryImpl() {

            GetAllUsers = LocalStaticData.users;
        }
        public List<UserLocalEntity> GetAllUsers
        { get; set; }

        public List<UserLocalEntity> GetAllUser()
        {
            return GetAllUsers;
        }

        public bool RemoveUserByGuid(Guid userGuid)
        {
            UserLocalEntity? userLocal = GetAllUsers
                .Where(x => x.Guid == userGuid).FirstOrDefault();
            if (userLocal == null) return false;

            return GetAllUsers.Remove(userLocal);
        }

        public UserLocalEntity? GetUserByGuid(Guid userGuid) {
            UserLocalEntity? userLocal = GetAllUsers
                    .Where(x => x.Guid == userGuid).FirstOrDefault();
            if (userLocal == null) return null;

            return userLocal;
        }

        public UserLocalEntity? UpdateUser(UserLocalEntity userUpdateLocalEntity) {
            int index = GetAllUsers.FindIndex(x => x.Guid == userUpdateLocalEntity.Guid);
            if (index == -1) return null;
            GetAllUsers[index].FIO = userUpdateLocalEntity.FIO;
            GetAllUsers[index].GroupID = userUpdateLocalEntity.GroupID;
            return GetAllUsers[index];
        }
    }
}