using Demo.Domain.UseCase;
using Demo.domain.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Demo.UI
{
    public class MainMenuUI
    {

        UserConsoleUI _userConsoleUI;
        GroupConsoleUI _groupConsoleUI;

        public MainMenuUI(UserUseCase userUseCase, GroupUseCase groupUseCase) { 
        _userConsoleUI = new UserConsoleUI(userUseCase);
        _groupConsoleUI = new GroupConsoleUI(groupUseCase);
            DisplayMenu();
            
        }

        private void DisplayMenu() {
            while (true)
            {
                switch (Console.ReadLine())
                {
                    case "1": _userConsoleUI.DisplayAllUsers(); break;
                    case "2": _userConsoleUI.RemoveUserByGuid(Guid.Parse(Console.ReadLine())); break;
                    case "3": _userConsoleUI.UpdateUser(User.Parse(Console.ReadLine())); break;
                    case "4": _userConsoleUI.GetUserByGuid(Guid.Parse(Console.ReadLine())); break;
                    case "5": _groupConsoleUI.DisplayAllGroups(); break;
                    case "6": _groupConsoleUI.CreateNewGroup(Group.Parse(Console.ReadLine())); break;
                    case "7": _groupConsoleUI.UpdateGroupName(Group.Parse(Console.ReadLine())); break;

                    default: DisplayMenu();
                        break;
                }

            }
        }
        
    }
}